using System;
using System.CodeDom.Compiler;
using System.Collections.Generic;
using System.Reflection;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Media;
using System.Windows.Shapes;

namespace TestProject
{
    /// <summary>
    ///  
    /// </summary>
    public partial class MainWindow : Window
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// ġ Ʈ
        /// </summary>
        private Matrix worldToDeviceMatrix;
        
        /// <summary>
        /// ġ Ʈ
        /// </summary>
        private Matrix deviceToWorldMatrix;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - MainWindow()

        /// <summary>
        /// 
        /// </summary>
        public MainWindow()
        {
            InitializeComponent();

            Loaded                += Window_Loaded;
            this.drawButton.Click += drawButton_Click;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private
        //////////////////////////////////////////////////////////////////////////////// Event

        #region  ε óϱ - Window_Loaded(sender, e)

        /// <summary>
        ///  ε óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            int equation = 2;

            switch(equation)
            {
                case 1 :

                    this.equationTextBox.Text = "10 * Math.Sin(x) / x";
                    this.minimymXTextBox.Text = "-20";
                    this.maximymXTextBox.Text = "20";
                    this.minimumYTextBox.Text = "-5";
                    this.maximumYTextBox.Text = "20";

                    break;

                case 2 :

                    this.equationTextBox.Text = "x * x / (x * x - 1)";
                    this.minimymXTextBox.Text = "-6";
                    this.maximymXTextBox.Text = "6";
                    this.minimumYTextBox.Text = "-3";
                    this.maximumYTextBox.Text = "5";

                    break;

                case 3 :

                    this.equationTextBox.Text = "5 * Math.Sin(x)";
                    this.minimymXTextBox.Text = "-6";
                    this.maximymXTextBox.Text = "6";
                    this.minimumYTextBox.Text = "-4";
                    this.maximumYTextBox.Text = "4";

                    break;

                case 4 :

                    this.equationTextBox.Text = "Math.Abs(x) / x / 2";
                    this.minimymXTextBox.Text = "-3";
                    this.maximymXTextBox.Text = "3";
                    this.minimumYTextBox.Text = "-2";
                    this.maximumYTextBox.Text = "2";

                    break;
            }
        }

        #endregion
        #region ׸ ư Ŭ óϱ - drawButton_Click(sender, e)

        /// <summary>
        /// ׸ ư Ŭ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void drawButton_Click(object sender, RoutedEventArgs e)
        {
            DrawGraph();
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////// Function

        #region Ⱦ ϱ - AdjustAspectRatio(worldMinimumX, worldMaximumX, worldMinimumY, worldMaximumY, deviceMinimymX, deviceMaximumX, deviceMinimumY, deviceMaximumY)

        /// <summary>
        /// Ⱦ ϱ
        /// </summary>
        /// <param name="worldMinimumX"> ּ X</param>
        /// <param name="worldMaximumX"> ִ X</param>
        /// <param name="worldMinimumY"> ּ Y</param>
        /// <param name="worldMaximumY"> ִ Y</param>
        /// <param name="deviceMinimymX">ġ ּ X</param>
        /// <param name="deviceMaximumX">ġ ִ X</param>
        /// <param name="deviceMinimumY">ġ ּ Y</param>
        /// <param name="deviceMaximumY">ġ ִ Y</param>
        private void AdjustAspectRatio
        (
            ref double worldMinimumX,
            ref double worldMaximumX,
            ref double worldMinimumY,
            ref double worldMaximumY,
            double     deviceMinimymX,
            double     deviceMaximumX,
            double     deviceMinimumY,
            double     deviceMaximumY
        )
        {
            double deltaWorldX = worldMaximumX - worldMinimumX;
            double deltaWorldY = worldMaximumY - worldMinimumY;

            double deltaDeviceX = deviceMaximumX - deviceMinimymX;
            double deltaDeviceY = deviceMaximumY - deviceMinimumY;

            double worldAspectRatio  = deltaWorldX / deltaWorldY;
            double deviceAspectRatio = Math.Abs(deltaDeviceX / deltaDeviceY);

            if(worldAspectRatio > deviceAspectRatio)
            {
                deltaWorldY = deltaWorldX / deviceAspectRatio;

                double worldCenterY = (worldMaximumY + worldMinimumY) / 2;

                worldMinimumY = worldCenterY - deltaWorldY / 2;
                worldMaximumY = worldCenterY + deltaWorldY / 2;
            }
            else
            {
                deltaWorldX = deltaWorldY * deviceAspectRatio;

                double worldCenterX = (worldMaximumX + worldMinimumX) / 2;

                worldMinimumX = worldCenterX - deltaWorldX / 2;
                worldMaximumX = worldCenterX + deltaWorldX / 2;
            }
        }

        #endregion
        #region Ʈ ϱ - SetMatrix(worldMinimumX, worldMaximumX, worldMinimumY, worldMaximumY, deviceMinimumX, deviceMaximumX, deviceMinimumY, deviceMaximumY)

        /// <summary>
        /// Ʈ ϱ
        /// </summary>
        /// <param name="worldMinimumX"> ּ X</param>
        /// <param name="worldMaximumX"> ִ X</param>
        /// <param name="worldMinimumY"> ּ Y</param>
        /// <param name="worldMaximumY"> ִ Y</param>
        /// <param name="deviceMinimumX">ġ ּ X</param>
        /// <param name="deviceMaximumX">ġ ִ X</param>
        /// <param name="deviceMinimumY">ġ ּ Y</param>
        /// <param name="deviceMaximumY">ġ ִ Y</param>
        private void SetMatrix
        (
            double worldMinimumX,
            double worldMaximumX,
            double worldMinimumY,
            double worldMaximumY,
            double deviceMinimumX,
            double deviceMaximumX,
            double deviceMinimumY,
            double deviceMaximumY
        )
        {
            this.worldToDeviceMatrix = Matrix.Identity;

            this.worldToDeviceMatrix.Translate(-worldMinimumX, -worldMinimumY);

            double scaleX = (deviceMaximumX - deviceMinimumX) / (worldMaximumX - worldMinimumX);
            double scaleY = (deviceMaximumY - deviceMinimumY) / (worldMaximumY - worldMinimumY);

            this.worldToDeviceMatrix.Scale(scaleX, scaleY);

            this.worldToDeviceMatrix.Translate(deviceMinimumX, deviceMinimumY);

            this.deviceToWorldMatrix = worldToDeviceMatrix;

            this.deviceToWorldMatrix.Invert();
        }

        #endregion
        #region ġ Ʈ ϱ - GetDevicePoint(worldPoint)

        /// <summary>
        /// ġ Ʈ ϱ
        /// </summary>
        /// <param name="worldPoint"> Ʈ</param>
        /// <returns>ġ Ʈ</returns>
        private Point GetDevicePoint(Point worldPoint)
        {
            return this.worldToDeviceMatrix.Transform(worldPoint);
        }

        #endregion
        #region  Ʈ ϱ - GetWorldPoint(devicePoint)

        /// <summary>
        ///  Ʈ ϱ
        /// </summary>
        /// <param name="devicePoint">ġ Ʈ</param>
        /// <returns> Ʈ</returns>
        private Point GetWorldPoint(Point devicePoint)
        {
            return deviceToWorldMatrix.Transform(devicePoint);
        }

        #endregion
        #region  ׸ - DrawAxes(canvas, minimumX, maximumX, minimumY, maximumY)

        /// <summary>
        ///  ׸
        /// </summary>
        /// <param name="canvas">ĵ</param>
        /// <param name="minimumX">ּ X</param>
        /// <param name="maximumX">ִ X</param>
        /// <param name="minimumY">ּ Y</param>
        /// <param name="maximumY">ִ Y</param>
        private void DrawAxes(Canvas canvas, double minimumX, double maximumX, double minimumY, double maximumY)
        {
            const double TICK_WIDTH = 0.5;

            double startX = (int)minimumX;

            if(startX == minimumX)
            {
                startX++;
            }

            double stopX = (int)maximumX;

            if(stopX == maximumX)
            {
                stopX--;
            }

            Point point       = new Point(0, 0);
            Point originPoint = GetDevicePoint(point);

            GeometryGroup xAxisGeometryGroup = new GeometryGroup();

            xAxisGeometryGroup.Children.Add
            (
                new LineGeometry
                (
                    new Point(0                      , originPoint.Y),
                    new Point(this.canvas.ActualWidth, originPoint.Y)
                )
            );

            double y1 = -TICK_WIDTH / 2;
            double y2 =  TICK_WIDTH / 2;

            for(double x = startX; x <= stopX; x++)
            {
                Point point1 = new Point(x, y1);
                Point point2 = new Point(x, y2);

                xAxisGeometryGroup.Children.Add
                (
                    new LineGeometry
                    (
                        GetDevicePoint(point1),
                        GetDevicePoint(point2)
                    )
                );
            }

            Path xAxisPath = new Path();

            xAxisPath.Stroke          = Brushes.Black;
            xAxisPath.StrokeThickness = 1;
            xAxisPath.Data            = xAxisGeometryGroup;

            this.canvas.Children.Add(xAxisPath);

            double startY = (int)minimumY;

            if(startY == minimumY)
            {
                startY++;
            }

            double stopY = (int)maximumY;

            if(stopY == maximumY)
            {
                stopY--;
            }

            GeometryGroup yAxisGeometryGroup = new GeometryGroup();

            yAxisGeometryGroup.Children.Add
            (
                new LineGeometry
                (
                    new Point(originPoint.X, 0),
                    new Point(originPoint.X, this.canvas.ActualHeight)
                )
            );

            double x1 = -TICK_WIDTH / 2;
            double x2 =  TICK_WIDTH / 2;

            for(double y = startY; y <= stopY; y++)
            {
                Point point1 = new Point(x1, y);
                Point point2 = new Point(x2, y);

                yAxisGeometryGroup.Children.Add
                (
                    new LineGeometry
                    (
                        GetDevicePoint(point1),
                        GetDevicePoint(point2)
                    )
                );
            }

            Path yAxisPath = new Path();

            yAxisPath.Stroke          = Brushes.Black;
            yAxisPath.StrokeThickness = 1;
            yAxisPath.Data            = yAxisGeometryGroup;

            this.canvas.Children.Add(yAxisPath);
        }

        #endregion
        #region ٰ ϱ - SetPolyline(canvas, pointList)

        /// <summary>
        /// ٰ ϱ
        /// </summary>
        /// <param name="canvas">ĵ</param>
        /// <param name="pointList">Ʈ Ʈ</param>
        private void SetPolyline(Canvas canvas, List<Point> pointList)
        {
            PointCollection pointCollection = new PointCollection(pointList.Count);

            foreach(Point point in pointList)
            {
                pointCollection.Add(GetDevicePoint(point));
            }

            Polyline polyline = new Polyline();

            polyline.Stroke          = Brushes.Red;
            polyline.StrokeThickness = 1;
            polyline.Points          = pointCollection;

            canvas.Children.Add(polyline);
        }

        #endregion
        #region  ׸ - DrawCurve(canvas, minimumX, maximumX, minimumY, maximumY, equation)

        /// <summary>
        ///  ׸
        /// </summary>
        /// <param name="canvas">ĵ</param>
        /// <param name="minimumX">ּ X</param>
        /// <param name="maximumX">ִ X</param>
        /// <param name="minimumY">ּ Y</param>
        /// <param name="maximumY">ִ Y</param>
        /// <param name="equation"></param>
        private void DrawCurve(Canvas canvas, double minimumX, double maximumX, double minimumY, double maximumY, string equation)
        {
            string functionText = "using System;"                               +
                                  "public static class Evaluator"               +
                                  "{"                                           +
                                  "    public static double Evaluate(double x)" +
                                  "    {"                                       +
                                  "        return " + equation + ";"            +
                                  "    }"                                       +
                                  "}";

            CodeDomProvider codeDomProvider = CodeDomProvider.CreateProvider("C#");

            CompilerParameters compilerParameters = new CompilerParameters();

            compilerParameters.GenerateInMemory   = true;
            compilerParameters.GenerateExecutable = false;

            CompilerResults compilerResults = codeDomProvider.CompileAssemblyFromSource(compilerParameters, functionText);

            if(compilerResults.Errors.Count > 0)
            {
                string message = "Error compiling the expression.";

                foreach(CompilerError compilerError in compilerResults.Errors)
                {
                    message += "\n" + compilerError.ErrorText;
                }

                MessageBox.Show(message, "ERROR", MessageBoxButton.OK, MessageBoxImage.Error);
            }
            else
            {
                Type evaluatorType = compilerResults.CompiledAssembly.GetType("Evaluator");

                MethodInfo methodInfo = evaluatorType.GetMethod("Evaluate");

                Point point0 = GetWorldPoint(new Point(0, 0));
                Point point1 = GetWorldPoint(new Point(1, 1));

                double deltaX = point1.X - point0.X;

                List<Point> pointList = new List<Point>();

                bool lastPointInBounds = false;

                for(double x = minimumX; x <= maximumX; x += deltaX)
                {
                    bool pointInBounds = false;

                    try
                    {
                        object[] methodParameterArray = new object[] { x };

                        double y = (double)methodInfo.Invoke(null, methodParameterArray);

                        if(double.IsNaN(y))
                        {
                        }
                        else
                        {
                            if(y < minimumY)
                            {
                                y = minimumY;
                            }
                            else if(y > maximumY)
                            {
                                y = maximumY;
                            }
                            else
                            {
                                pointInBounds = true;
                            }

                            pointList.Add(new Point(x, y));
                        }

                        if(!pointInBounds)
                        {
                            if(lastPointInBounds)
                            {
                                SetPolyline(this.canvas, pointList);

                                pointList.Clear();
                            }
                            else
                            {
                                if(pointList.Count > 1)
                                {
                                    pointList.RemoveAt(0);
                                }
                            }
                        }

                        lastPointInBounds = pointInBounds;
                    }
                    catch(Exception exception)
                    {
                        MessageBox.Show(exception.Message);

                        return;
                    }
                }

                if(pointList.Count > 1)
                {
                    SetPolyline(this.canvas, pointList);
                }
            }
        }

        #endregion
        #region ׷ ׸ - DrawGraph()

        /// <summary>
        /// ׷ ׸
        /// </summary>
        private void DrawGraph()
        {
            this.canvas.Children.Clear();

            double worldMinimumX = double.Parse(this.minimymXTextBox.Text);
            double worldMaximumX = double.Parse(this.maximymXTextBox.Text);
            double worldMinimumY = double.Parse(this.minimumYTextBox.Text);
            double worldMaximumY = double.Parse(this.maximumYTextBox.Text);

            string equation = this.equationTextBox.Text;

            double deviceMaximumX = this.canvas.ActualWidth;
            double deviceMaximumY = this.canvas.ActualHeight;

            AdjustAspectRatio
            (
                ref worldMinimumX,
                ref worldMaximumX,
                ref worldMinimumY,
                ref worldMaximumY,
                0,
                deviceMaximumX,
                deviceMaximumY,
                0
            );

            SetMatrix(worldMinimumX, worldMaximumX, worldMinimumY, worldMaximumY, 0, deviceMaximumX, deviceMaximumY, 0);

            DrawAxes(this.canvas, worldMinimumX, worldMaximumX, worldMinimumY, worldMaximumY);

            DrawCurve(this.canvas, worldMinimumX, worldMaximumX, worldMinimumY, worldMaximumY, equation);
        }

        #endregion
    }
}